diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.c strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.c
--- strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.c	2022-07-08 11:18:02.028706000 +0300
@@ -16,6 +16,11 @@
 #include <unistd.h>
 #include <fcntl.h>
 
+#ifdef WIN32
+#include <signal.h>
+#include <synchapi.h>
+#endif
+
 #include "kernel_libipsec_router.h"
 
 #include <daemon.h>
@@ -25,6 +30,7 @@
 #include <threading/rwlock.h>
 #include <threading/thread.h>
 #include <processing/jobs/callback_job.h>
+#include <processing/jobs/acquire_job.h>
 
 typedef struct private_kernel_libipsec_router_t private_kernel_libipsec_router_t;
 
@@ -35,7 +41,11 @@
 	/** virtual IP (points to internal data of tun) */
 	host_t *addr;
 	/** underlying TUN file descriptor (cached from tun) */
+#ifdef WIN32
+	HANDLE handle;
+#else
 	int fd;
+#endif /* !WIN32 */
 	/** TUN device */
 	tun_device_t *tun;
 } tun_entry_t;
@@ -71,10 +81,44 @@
 	 */
 	rwlock_t *lock;
 
+#ifdef WIN32
+	/**
+	 * Event we use to signal handle_plain() about changes regarding tun devices
+	 */
+	HANDLE event;
+	
+	/**
+	 * This is a notification value that we atomically set and reset if we don't use events right now.
+	 * It's used so we can avoid using WaitFor* functions when busy looping.
+	 */
+	volatile bool notify;
+	
+	/**
+	 * Setting for waiting on event or using busy loop
+	 */
+	bool use_events;
+	
+	/**
+	 * Whether a packet could be read from any of the tun devices in the last
+	 * iteration of handle_plain
+	 */
+	bool got_result;
+	
+	/**
+	 * How long the spinloop should run in microseconds after failing to
+	 * get a packet before it waits for events again.
+	 */
+	uint64_t spinloop_threshold;
+	
+	LARGE_INTEGER switching_time;
+	
+	bool windows_close;
+#else
 	/**
 	 * Pipe to signal handle_plain() about changes regarding TUN devices
 	 */
 	int notify[2];
+#endif
 };
 
 /**
@@ -102,6 +146,19 @@
 }
 
 /**
+ * Raise an acquire event
+ */
+static void raise_acquire(void *data, uint32_t reqid,
+			  traffic_selector_t *source_ts,
+			  traffic_selector_t *destination_ts)
+{
+	lib->processor->queue_job(lib->processor, (job_t *) acquire_job_create(
+		 reqid,
+		 source_ts,
+		 destination_ts));
+}
+
+/**
  * Receiver callback
  */
 static void receiver_esp_cb(void *data, packet_t *packet)
@@ -152,6 +209,25 @@
 	}
 }
 
+static bool process_plain_wintun(tun_device_t *tun)
+{
+	chunk_t raw;
+	if (tun->read_packet(tun, &raw))
+	{
+		ip_packet_t *packet;
+
+		packet = ip_packet_create(raw);
+		if (packet)
+		{
+			ipsec->processor->queue_outbound(ipsec->processor, packet);
+		}
+		return TRUE;
+	}
+	return FALSE;
+}
+
+#ifndef WIN32
+
 /**
  * Find flagged revents in a pollfd set by fd
  */
@@ -169,6 +245,8 @@
 	return 0;
 }
 
+#endif
+
 /**
  * Job handling outbound plaintext packets
  */
@@ -176,13 +254,13 @@
 {
 	enumerator_t *enumerator;
 	tun_entry_t *entry;
-	bool oldstate;
 	int count = 0;
+#ifndef WIN32
+	bool oldstate;
 	char buf[1];
 	struct pollfd *pfd;
 
 	this->lock->read_lock(this->lock);
-
 	pfd = alloca(sizeof(*pfd) * (this->tuns->get_count(this->tuns) + 2));
 	pfd[count].fd = this->notify[0];
 	pfd[count].events = POLLIN;
@@ -190,7 +268,6 @@
 	pfd[count].fd = this->tun.fd;
 	pfd[count].events = POLLIN;
 	count++;
-
 	enumerator = this->tuns->create_enumerator(this->tuns);
 	while (enumerator->enumerate(enumerator, NULL, &entry))
 	{
@@ -234,7 +311,180 @@
 		}
 	}
 	enumerator->destroy(enumerator);
-	this->lock->unlock(this->lock);
+#else
+	LARGE_INTEGER StartingTime = { .QuadPart = 0 },
+		EndingTime = { .QuadPart = 0 },
+		ElapsedMicroseconds = { .QuadPart = 0},
+		Frequency = { .QuadPart = 0};
+	uint64_t processed_packets = 0, failed_calls = 0;
+	
+	QueryPerformanceFrequency(&Frequency); 	
+	
+	this->lock->read_lock(this->lock);
+	if(this->use_events || !this->got_result) {
+		DBG2(DBG_LIB, "Running in event driven mode.");
+		QueryPerformanceCounter(&this->switching_time);
+		HANDLE *tun_handles;
+		DWORD ret;
+		/* Check if any of the TUN devices has data for reading */
+		tun_handles = alloca(sizeof(HANDLE)* (this->tuns->get_count(this->tuns)+2));
+		tun_handles[count] = this->event;
+		count++;
+		tun_handles[count] = this->tun.handle;
+		count++;
+		enumerator = this->tuns->create_enumerator(this->tuns);
+		while (enumerator->enumerate(enumerator, NULL, &entry))
+		{
+			tun_handles[count] = entry->handle;
+			count++;
+		}
+
+		enumerator->destroy(enumerator);
+		this->lock->unlock(this->lock);
+		QueryPerformanceCounter(&StartingTime);
+		ret = WaitForMultipleObjects(count, tun_handles, FALSE, INFINITE);
+		QueryPerformanceCounter(&EndingTime);
+		ElapsedMicroseconds.QuadPart = EndingTime.QuadPart - StartingTime.QuadPart;
+		ElapsedMicroseconds.QuadPart *= 1000000000;
+		ElapsedMicroseconds.QuadPart /= Frequency.QuadPart;
+		DBG2(DBG_LIB, "Waited for %lld nanoseconds (%lld miliseconds)", ElapsedMicroseconds.QuadPart, ElapsedMicroseconds.QuadPart/1000000);
+		this->lock->read_lock(this->lock);
+		if (ret >= WAIT_OBJECT_0 || ret <= WAIT_OBJECT_0 + count -1)
+		{
+			int offset = ret - WAIT_OBJECT_0;
+			this->got_result = TRUE;
+			switch(offset)
+			{
+				case 0:
+					DBG2(DBG_LIB, "Interrupt job from event");
+					ResetEvent(tun_handles[offset]);
+					break;
+				case 1:
+					DBG2(DBG_LIB, "got packet in event mode");
+					process_plain(this->tun.tun);
+					break;
+				default:
+					DBG2(DBG_LIB, "got packet in event mode");
+					enumerator = this->tuns->create_enumerator(this->tuns);
+					while (enumerator->enumerate(enumerator, NULL, &entry))
+					{
+						if (WaitForSingleObjectEx(entry->handle, 0, FALSE) == WAIT_OBJECT_0)
+						{
+							process_plain(entry->tun);
+						}
+					}
+					enumerator->destroy(enumerator);
+					break;
+			}
+		} else if (ret >= WAIT_ABANDONED_0 || ret <= WAIT_ABANDONED_0 + count -1)
+		{
+			int offset = ret - WAIT_ABANDONED_0;
+			this->got_result = FALSE;
+			switch(offset)
+			{
+				case 0:
+					DBG2(DBG_LIB, "Notify handle closed.");
+					break;
+				case 1:
+					DBG2(DBG_LIB, "Primary tun handle closed");
+					break;
+				default:
+					DBG2(DBG_LIB, "Other tun handle closed at offset %d", offset);
+					break;
+			}
+			return JOB_REQUEUE_NONE;
+		}
+		else if (ret == WAIT_FAILED)
+		{
+			char error_buf[512];
+			DBG1(DBG_LIB, "Failed to wait for tun devices to be ready for reading: %s",
+			dlerror_mt(error_buf, sizeof(error_buf)));
+		}
+		QueryPerformanceCounter(&this->switching_time);
+	} else {
+		/* TODO: Set realtime priority for charon-svc.exe
+		 * (otherwise Windows suspends the process after only a couple
+		 * of processes or stops waking up the process events)
+		 */
+		this->lock->read_lock(this->lock);
+		/* Check each handle individually */
+		QueryPerformanceCounter(&EndingTime);
+		ElapsedMicroseconds.QuadPart = EndingTime.QuadPart - this->switching_time.QuadPart;
+		ElapsedMicroseconds.QuadPart *= 1000000000;
+		ElapsedMicroseconds.QuadPart /= Frequency.QuadPart;
+		DBG2(DBG_LIB, "Delay between switching is %lld nanoseconds", ElapsedMicroseconds.QuadPart);
+		do {
+			/* Because the NT kernel scheduler stops waking up the process
+			 * if we wait too often, we need to avoid calling any WaitFor* functions.
+			 * Thus we busy loop in user space until we get no result for some time */
+			this->got_result = FALSE;
+			if(process_plain_wintun(this->tun.tun))
+			{
+				this->got_result |= TRUE;
+				processed_packets++;
+			} else {
+				failed_calls++;
+			}
+			
+			ResetEvent(this->tun.handle);
+			enumerator = this->tuns->create_enumerator(this->tuns);
+			while(enumerator->enumerate(enumerator, NULL, &entry))
+			{
+				if (process_plain_wintun(entry->tun))
+				{
+					processed_packets++;
+					this->got_result |= TRUE;
+				} else {
+					failed_calls++;
+				}
+				ResetEvent(entry->handle);
+			}
+			enumerator->destroy(enumerator);
+			
+			if (!this->got_result)
+			{
+				if(!StartingTime.QuadPart) {
+					QueryPerformanceCounter(&StartingTime);
+				} else {
+					QueryPerformanceCounter(&EndingTime);
+					ElapsedMicroseconds.QuadPart = EndingTime.QuadPart - StartingTime.QuadPart;
+					ElapsedMicroseconds.QuadPart *= 1000000000;
+					ElapsedMicroseconds.QuadPart /= Frequency.QuadPart;
+				}
+				enumerator = this->tuns->create_enumerator(this->tuns);
+				while(enumerator->enumerate(enumerator, NULL, &entry))
+				{
+					ResetEvent(entry->handle);
+				}
+				enumerator->destroy(enumerator);
+				if (ElapsedMicroseconds.QuadPart >= this->spinloop_threshold)
+				{
+					DBG2(DBG_LIB, "Processed %lld packets,"
+						" failed %lld calls to read packets"
+					 " Reached threshold at %lld nanoseconds, switching"
+					 " back to events.",
+					 processed_packets,
+					 failed_calls,
+					 ElapsedMicroseconds.QuadPart);
+					ResetEvent(this->event);
+					this->notify = FALSE;
+					break;
+				}
+			}
+			if(this->notify)
+			{
+				DBG2(DBG_LIB, "Processed %lld packets, Interrupt job from bool", processed_packets);
+				ResetEvent(this->event);
+				this->notify = FALSE;
+				break;
+			}
+
+		}
+		while(TRUE);
+	}
+ 
+#endif /* WIN32 */
+	this->lock->unlock(this->lock);	
 
 	return JOB_REQUEUE_DIRECT;
 }
@@ -243,14 +493,20 @@
 	private_kernel_libipsec_router_t *this, tun_device_t *tun, bool created)
 {
 	tun_entry_t *entry, lookup;
+#ifndef WIN32
 	char buf[] = {0x01};
+#endif
 
 	this->lock->write_lock(this->lock);
 	if (created)
 	{
 		INIT(entry,
 			.addr = tun->get_address(tun, NULL),
+#ifdef WIN32
+			.handle = tun->get_handle(tun),
+#else
 			.fd = tun->get_fd(tun),
+#endif /* !WIN32 */
 			.tun = tun,
 		);
 		this->tuns->put(this->tuns, entry, entry);
@@ -262,7 +518,12 @@
 		free(entry);
 	}
 	/* notify handler thread to recreate FD set */
+#ifdef WIN32
+	SetEvent(this->event);
+	this->notify = TRUE;
+#else
 	ignore_result(write(this->notify[1], buf, sizeof(buf)));
+#endif
 	this->lock->unlock(this->lock);
 	return TRUE;
 }
@@ -297,15 +558,25 @@
 										 (ipsec_outbound_cb_t)send_esp);
 	ipsec->processor->unregister_inbound(ipsec->processor,
 										 (ipsec_inbound_cb_t)deliver_plain);
+	ipsec->processor->unregister_acquire(ipsec->processor,
+		 (ipsec_acquire_cb_t)raise_acquire);
 	charon->kernel->remove_listener(charon->kernel, &this->public.listener);
-	this->lock->destroy(this->lock);
-	this->tuns->destroy(this->tuns);
+#ifdef WIN32
+	SetEvent(this->event);
+	this->tun.tun->destroy(this->tun.tun);
+	CloseHandle(this->tun.handle);
+	CloseHandle(this->event);
+#else
 	close(this->notify[0]);
 	close(this->notify[1]);
+#endif
+	this->lock->destroy(this->lock);
+	this->tuns->destroy(this->tuns);	
 	router = NULL;
 	free(this);
 }
 
+#ifndef WIN32
 /**
  * Set O_NONBLOCK on the given socket.
  */
@@ -314,6 +585,24 @@
 	int flags = fcntl(socket, F_GETFL);
 	return flags != -1 && fcntl(socket, F_SETFL, flags | O_NONBLOCK) != -1;
 }
+#endif
+
+#ifdef WIN32
+/**
+ * See header file
+ */
+METHOD(kernel_libipsec_router_t, reload, void,
+	private_kernel_libipsec_router_t *this)
+{
+	this->use_events = lib->settings->get_bool(
+		lib->settings, "%s.use_events", FALSE, lib->ns);
+	this->spinloop_threshold = lib->settings->get_int(
+		lib->settings, "%s.spinloop_threshold", 4000000, lib->ns);
+	DBG1(DBG_LIB, "Read new use_events setting %d and spinloop_threshold %lld",
+	this->use_events, this->spinloop_threshold);
+}
+
+#endif
 
 /*
  * See header file
@@ -329,12 +618,25 @@
 			},
 			.get_tun_name = _get_tun_name,
 			.destroy = _destroy,
+			.reload = _reload,
 		},
 		.tun = {
 			.tun = lib->get(lib, "kernel-libipsec-tun"),
-		}
+		},
+#ifdef WIN32
+		.notify = FALSE,
+#endif
 	);
-
+	this->public.reload(&this->public);
+#ifdef WIN32
+	this->tun.handle = this->tun.tun->get_handle(this->tun.tun);
+        if (!(this->event = CreateEvent(NULL, FALSE, FALSE, FALSE)))
+        {
+            DBG1(DBG_KNL, "creating notify event for kernel-libipsec router failed");
+            free(this);
+            return NULL;
+        }
+#else
 	if (pipe(this->notify) != 0 ||
 		!set_nonblock(this->notify[0]) || !set_nonblock(this->notify[1]))
 	{
@@ -345,6 +647,7 @@
 
 	this->tun.fd = this->tun.tun->get_fd(this->tun.tun);
 
+#endif /* !WIN32 */
 	this->tuns = hashtable_create((hashtable_hash_t)tun_entry_hash,
 								  (hashtable_equals_t)tun_entry_equals, 4);
 	this->lock = rwlock_create(RWLOCK_TYPE_DEFAULT);
@@ -353,6 +656,7 @@
 	ipsec->processor->register_outbound(ipsec->processor, send_esp, NULL);
 	ipsec->processor->register_inbound(ipsec->processor,
 									(ipsec_inbound_cb_t)deliver_plain, this);
+	ipsec->processor->register_acquire(ipsec->processor, raise_acquire, NULL);
 	charon->receiver->add_esp_cb(charon->receiver,
 									(receiver_esp_cb_t)receiver_esp_cb, NULL);
 	lib->processor->queue_job(lib->processor,
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.h strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.h
--- strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_router.h	2022-07-08 11:18:46.529662000 +0300
@@ -48,6 +48,14 @@
 	 * Destroy the given instance
 	 */
 	void (*destroy)(kernel_libipsec_router_t *this);
+
+#ifdef WIN32   
+   /**
+    * Reload the configuration of the router 
+    */
+   void (*reload)(kernel_libipsec_router_t *this);
+#endif
+
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_netlink/kernel_netlink_ipsec.c strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_netlink/kernel_netlink_ipsec.c
--- strongswan-5.8.4/src/libcharon/plugins/kernel_netlink/kernel_netlink_ipsec.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_netlink/kernel_netlink_ipsec.c	2022-07-06 15:47:33.870969000 +0300
@@ -228,6 +228,16 @@
 /*	{ENCR_CAMELLIA_CCM_ICV12,	"***"				}, */
 /*	{ENCR_CAMELLIA_CCM_ICV16,	"***"				}, */
 	{ENCR_SERPENT_CBC,			"serpent"			},
+	{ENCR_GOST28147_CTR_LEGACY,	"ctr(gost)"			},
+	{ENCR_GOST28147_CFB_LEGACY,	"cfb(gost)"			},
+	{ENCR_BELT_CBC_LEGACY,		"cbc(belt)"			},
+	{ENCR_BELT_CFB_LEGACY,		"cfb(belt)"			},
+	{ENCR_BELT_CTR_LEGACY,		"ctr(belt)"			},
+	{ENCR_GOST28147_CTR,		"ctr(gost)"			},
+	{ENCR_GOST28147_CFB,		"cfb(gost)"			},
+	{ENCR_BELT_CBC,				"cbc(belt)"			},
+	{ENCR_BELT_CFB,				"cfb(belt)"			},
+	{ENCR_BELT_CTR,				"ctr(belt)"			},
 	{ENCR_TWOFISH_CBC,			"twofish"			},
 	{ENCR_CHACHA20_POLY1305,	"rfc7539esp(chacha20,poly1305)"},
 };
@@ -247,6 +257,14 @@
 /*	{AUTH_DES_MAC,				"***"				}, */
 /*	{AUTH_KPDK_MD5,				"***"				}, */
 	{AUTH_AES_XCBC_96,			"xcbc(aes)"			},
+	{AUTH_BELT_HASH_LEGACY,		"belt_hash"			},
+	{AUTH_GOST_MAC_LEGACY,		"gost_mac"			},
+	{AUTH_BELT_MAC_LEGACY,		"belt_mac"			},
+	{AUTH_BELT_HMAC_LEGACY,		"belt_hmac"			},
+	{AUTH_BELT_HASH,			"belt_hash"			},
+	{AUTH_GOST_MAC,			 	"gost_mac"			},
+	{AUTH_BELT_MAC,			 	"belt_mac"			},
+	{AUTH_BELT_HMAC,		 	"belt_hmac"			},
 	{AUTH_AES_CMAC_96,			"cmac(aes)"			},
 };
 
Двоичные файлы strongswan-5.8.4/src/libcharon/plugins/kernel_wfp/ipsecdump.exe и strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_wfp/ipsecdump.exe различаются
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.c strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.c
--- strongswan-5.8.4/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.c	2016-04-22 23:01:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.c	2020-11-30 16:52:55.000000000 +0300
@@ -15,118 +15,6 @@
 
 #include <library.h>
 
-const GUID FWPM_CONDITION_IP_REMOTE_ADDRESS = {
-	0xb235ae9a, 0x1d64, 0x49b8, { 0xa4,0x4c,0x5f,0xf3,0xd9,0x09,0x50,0x45 }
-};
-const GUID FWPM_CONDITION_IP_LOCAL_ADDRESS = {
-	0xd9ee00de, 0xc1ef, 0x4617, { 0xbf,0xe3,0xff,0xd8,0xf5,0xa0,0x89,0x57 }
-};
-const GUID FWPM_CONDITION_IP_SOURCE_ADDRESS = {
-	0xae96897e, 0x2e94, 0x4bc9, { 0xb3,0x13,0xb2,0x7e,0xe8,0x0e,0x57,0x4d }
-};
-const GUID FWPM_CONDITION_IP_DESTINATION_ADDRESS = {
-	0x2d79133b, 0xb390, 0x45c6, { 0x86,0x99,0xac,0xac,0xea,0xaf,0xed,0x33 }
-};
-const GUID FWPM_CONDITION_IP_LOCAL_PORT = {
-	0x0c1ba1af, 0x5765, 0x453f, { 0xaf,0x22,0xa8,0xf7,0x91,0xac,0x77,0x5b }
-};
-const GUID FWPM_CONDITION_IP_REMOTE_PORT = {
-	0xc35a604d, 0xd22b, 0x4e1a, { 0x91,0xb4,0x68,0xf6,0x74,0xee,0x67,0x4b }
-};
-const GUID FWPM_CONDITION_IP_PROTOCOL = {
-	0x3971ef2b, 0x623e, 0x4f9a, { 0x8c,0xb1,0x6e,0x79,0xb8,0x06,0xb9,0xa7 }
-};
-const GUID FWPM_LAYER_INBOUND_TRANSPORT_V4 = {
-	0x5926dfc8, 0xe3cf, 0x4426, { 0xa2,0x83,0xdc,0x39,0x3f,0x5d,0x0f,0x9d }
-};
-const GUID FWPM_LAYER_INBOUND_TRANSPORT_V6 = {
-	0x634a869f, 0xfc23, 0x4b90, { 0xb0,0xc1,0xbf,0x62,0x0a,0x36,0xae,0x6f }
-};
-const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V4 = {
-	0x09e61aea, 0xd214, 0x46e2, { 0x9b,0x21,0xb2,0x6b,0x0b,0x2f,0x28,0xc8 }
-};
-const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V6 = {
-	0xe1735bde, 0x013f, 0x4655, { 0xb3,0x51,0xa4,0x9e,0x15,0x76,0x2d,0xf0 }
-};
-const GUID FWPM_LAYER_IPFORWARD_V4 = {
-	0xa82acc24, 0x4ee1, 0x4ee1, { 0xb4,0x65,0xfd,0x1d,0x25,0xcb,0x10,0xa4}
-};
-const GUID FWPM_LAYER_IPFORWARD_V6 = {
-	0x7b964818, 0x19c7, 0x493a, { 0xb7,0x1f,0x83,0x2c,0x36,0x84,0xd2,0x8c }
-};
-const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V4 = {
-	0xc38d57d1, 0x05a7, 0x4c33, { 0x90,0x4f,0x7f,0xbc,0xee,0xe6,0x0e,0x82 }
-};
-const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V6 = {
-	0x4a72393b, 0x319f, 0x44bc, { 0x84,0xc3,0xba,0x54,0xdc,0xb3,0xb6,0xb4 }
-};
-const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V4 = {
-	0xe1cd9fe7, 0xf4b5, 0x4273, { 0x96,0xc0,0x59,0x2e,0x48,0x7b,0x86,0x50 }
-};
-const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V6 = {
-	0xa3b42c97, 0x9f04, 0x4672, { 0xb8,0x7e,0xce,0xe9,0xc4,0x83,0x25,0x7f }
-};
-const GUID FWPM_SUBLAYER_IPSEC_TUNNEL = {
-	0x83f299ed, 0x9ff4, 0x4967, { 0xaf,0xf4,0xc3,0x09,0xf4,0xda,0xb8,0x27 }
-};
-const GUID FWPM_SUBLAYER_IPSEC_FORWARD_OUTBOUND_TUNNEL = {
-	0xa5082e73, 0x8f71, 0x4559, { 0x8a,0x9a,0x10,0x1c,0xea,0x04,0xef,0x87 }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V4 = {
-	0x5132900d, 0x5e84, 0x4b5f, { 0x80,0xe4,0x01,0x74,0x1e,0x81,0xff,0x10 }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V6 = {
-	0x49d3ac92, 0x2a6c, 0x4dcf, { 0x95,0x5f,0x1c,0x3b,0xe0,0x09,0xdd,0x99 }
-};
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V4 = {
-	0x4b46bf0a, 0x4523, 0x4e57, { 0xaa,0x38,0xa8,0x79,0x87,0xc9,0x10,0xd9 }
-};
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V6 = {
-	0x38d87722, 0xad83, 0x4f11, { 0xa9,0x1f,0xdf,0x0f,0xb0,0x77,0x22,0x5b }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V4 = {
-	0x191a8a46, 0x0bf8, 0x46cf, { 0xb0,0x45,0x4b,0x45,0xdf,0xa6,0xa3,0x24 }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V6 = {
-	0x80c342e3, 0x1e53, 0x4d6f, { 0x9b,0x44,0x03,0xdf,0x5a,0xee,0xe1,0x54 }
-};
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V4 = {
-	0x70a4196c, 0x835b, 0x4fb0, { 0x98,0xe8,0x07,0x5f,0x4d,0x97,0x7d,0x46 }
-};
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V6 = {
-	0xf1835363, 0xa6a5, 0x4e62, { 0xb1,0x80,0x23,0xdb,0x78,0x9d,0x8d,0xa6 }
-};
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V4 = {
-	0x28829633, 0xc4f0, 0x4e66, { 0x87,0x3f,0x84,0x4d,0xb2,0xa8,0x99,0xc7 }
-};
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V6 = {
-	0xaf50bec2, 0xc686, 0x429a, { 0x88,0x4d,0xb7,0x44,0x43,0xe7,0xb0,0xb4 }
-};
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V4 = {
-	0xfb532136, 0x15cb, 0x440b, { 0x93,0x7c,0x17,0x17,0xca,0x32,0x0c,0x40 }
-};
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V6 = {
-	0xdae640cc, 0xe021, 0x4bee, { 0x9e,0xb6,0xa4,0x8b,0x27,0x5c,0x8c,0x1d }
-};
-const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V4 = {
-	0x6ac141fc, 0xf75d, 0x4203, { 0xb9,0xc8,0x48,0xe6,0x14,0x9c,0x27,0x12 }
-};
-const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V6 = {
-	0x4c0dda05, 0xe31f, 0x4666, { 0x90,0xb0,0xb3,0xdf,0xad,0x34,0x12,0x9a  }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V4 = {
-	0x3df6e7de, 0xfd20, 0x48f2, { 0x9f,0x26,0xf8,0x54,0x44,0x4c,0xba,0x79 }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V6 = {
-	0xa1e392d3, 0x72ac, 0x47bb, { 0x87,0xa7,0x01,0x22,0xc6,0x94,0x34,0xab }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V4 = {
-	0x7dff309b, 0xba7d, 0x4aba, { 0x91,0xaa,0xae,0x5c,0x66,0x40,0xc9,0x44 }
-};
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V6 = {
-	0xa9a0d6d9, 0xc58c, 0x474e, { 0x8a,0xeb,0x3c,0xfe,0x99,0xd6,0xd5,0x3d }
-};
-
 /**
  * Load a function symbol from a loaded dll
  */
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.h strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.h
--- strongswan-5.8.4/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.h	2016-04-22 23:01:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_wfp/kernel_wfp_compat.h	2020-11-30 16:52:55.000000000 +0300
@@ -107,50 +107,124 @@
 	IPSEC_SA_BUNDLE_FLAG_FORWARD_PATH_INITIATOR =				(1<<17),
 };
 
-/* missing in some MinGW versions */
-const GUID FWPM_CONDITION_IP_REMOTE_ADDRESS;
-const GUID FWPM_CONDITION_IP_LOCAL_ADDRESS;
-const GUID FWPM_CONDITION_IP_SOURCE_ADDRESS;
-const GUID FWPM_CONDITION_IP_DESTINATION_ADDRESS;
-const GUID FWPM_CONDITION_IP_LOCAL_PORT;
-const GUID FWPM_CONDITION_IP_REMOTE_PORT;
-const GUID FWPM_CONDITION_IP_PROTOCOL;
 #ifndef FWPM_CONDITION_ICMP_TYPE
 # define FWPM_CONDITION_ICMP_TYPE FWPM_CONDITION_IP_LOCAL_PORT
 #endif
 #ifndef FWPM_CONDITION_ICMP_CODE
 # define FWPM_CONDITION_ICMP_CODE FWPM_CONDITION_IP_REMOTE_PORT
 #endif
-const GUID FWPM_LAYER_INBOUND_TRANSPORT_V4;
-const GUID FWPM_LAYER_INBOUND_TRANSPORT_V6;
-const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V4;
-const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V6;
-const GUID FWPM_LAYER_IPFORWARD_V4;
-const GUID FWPM_LAYER_IPFORWARD_V6;
-const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V4;
-const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V6;
-const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V4;
-const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V6;
-const GUID FWPM_SUBLAYER_IPSEC_TUNNEL;
-const GUID FWPM_SUBLAYER_IPSEC_FORWARD_OUTBOUND_TUNNEL;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V4;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V6;
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V4;
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V6;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V4;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V6;
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V4;
-const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V6;
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V4;
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V6;
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V4;
-const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V6;
-const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V4;
-const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V6;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V4;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V6;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V4;
-const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V6;
+
+const GUID FWPM_CONDITION_IP_REMOTE_ADDRESS = {
+	0xb235ae9a, 0x1d64, 0x49b8, { 0xa4,0x4c,0x5f,0xf3,0xd9,0x09,0x50,0x45 }
+};
+const GUID FWPM_CONDITION_IP_LOCAL_ADDRESS = {
+	0xd9ee00de, 0xc1ef, 0x4617, { 0xbf,0xe3,0xff,0xd8,0xf5,0xa0,0x89,0x57 }
+};
+const GUID FWPM_CONDITION_IP_SOURCE_ADDRESS = {
+	0xae96897e, 0x2e94, 0x4bc9, { 0xb3,0x13,0xb2,0x7e,0xe8,0x0e,0x57,0x4d }
+};
+const GUID FWPM_CONDITION_IP_DESTINATION_ADDRESS = {
+	0x2d79133b, 0xb390, 0x45c6, { 0x86,0x99,0xac,0xac,0xea,0xaf,0xed,0x33 }
+};
+const GUID FWPM_CONDITION_IP_LOCAL_PORT = {
+	0x0c1ba1af, 0x5765, 0x453f, { 0xaf,0x22,0xa8,0xf7,0x91,0xac,0x77,0x5b }
+};
+const GUID FWPM_CONDITION_IP_REMOTE_PORT = {
+	0xc35a604d, 0xd22b, 0x4e1a, { 0x91,0xb4,0x68,0xf6,0x74,0xee,0x67,0x4b }
+};
+const GUID FWPM_CONDITION_IP_PROTOCOL = {
+	0x3971ef2b, 0x623e, 0x4f9a, { 0x8c,0xb1,0x6e,0x79,0xb8,0x06,0xb9,0xa7 }
+};
+const GUID FWPM_LAYER_INBOUND_TRANSPORT_V4 = {
+	0x5926dfc8, 0xe3cf, 0x4426, { 0xa2,0x83,0xdc,0x39,0x3f,0x5d,0x0f,0x9d }
+};
+const GUID FWPM_LAYER_INBOUND_TRANSPORT_V6 = {
+	0x634a869f, 0xfc23, 0x4b90, { 0xb0,0xc1,0xbf,0x62,0x0a,0x36,0xae,0x6f }
+};
+const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V4 = {
+	0x09e61aea, 0xd214, 0x46e2, { 0x9b,0x21,0xb2,0x6b,0x0b,0x2f,0x28,0xc8 }
+};
+const GUID FWPM_LAYER_OUTBOUND_TRANSPORT_V6 = {
+	0xe1735bde, 0x013f, 0x4655, { 0xb3,0x51,0xa4,0x9e,0x15,0x76,0x2d,0xf0 }
+};
+const GUID FWPM_LAYER_IPFORWARD_V4 = {
+	0xa82acc24, 0x4ee1, 0x4ee1, { 0xb4,0x65,0xfd,0x1d,0x25,0xcb,0x10,0xa4}
+};
+const GUID FWPM_LAYER_IPFORWARD_V6 = {
+	0x7b964818, 0x19c7, 0x493a, { 0xb7,0x1f,0x83,0x2c,0x36,0x84,0xd2,0x8c }
+};
+const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V4 = {
+	0xc38d57d1, 0x05a7, 0x4c33, { 0x90,0x4f,0x7f,0xbc,0xee,0xe6,0x0e,0x82 }
+};
+const GUID FWPM_LAYER_ALE_AUTH_CONNECT_V6 = {
+	0x4a72393b, 0x319f, 0x44bc, { 0x84,0xc3,0xba,0x54,0xdc,0xb3,0xb6,0xb4 }
+};
+const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V4 = {
+	0xe1cd9fe7, 0xf4b5, 0x4273, { 0x96,0xc0,0x59,0x2e,0x48,0x7b,0x86,0x50 }
+};
+const GUID FWPM_LAYER_ALE_AUTH_RECV_ACCEPT_V6 = {
+	0xa3b42c97, 0x9f04, 0x4672, { 0xb8,0x7e,0xce,0xe9,0xc4,0x83,0x25,0x7f }
+};
+const GUID FWPM_SUBLAYER_IPSEC_TUNNEL = {
+	0x83f299ed, 0x9ff4, 0x4967, { 0xaf,0xf4,0xc3,0x09,0xf4,0xda,0xb8,0x27 }
+};
+const GUID FWPM_SUBLAYER_IPSEC_FORWARD_OUTBOUND_TUNNEL = {
+	0xa5082e73, 0x8f71, 0x4559, { 0x8a,0x9a,0x10,0x1c,0xea,0x04,0xef,0x87 }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V4 = {
+	0x5132900d, 0x5e84, 0x4b5f, { 0x80,0xe4,0x01,0x74,0x1e,0x81,0xff,0x10 }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TRANSPORT_V6 = {
+	0x49d3ac92, 0x2a6c, 0x4dcf, { 0x95,0x5f,0x1c,0x3b,0xe0,0x09,0xdd,0x99 }
+};
+const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V4 = {
+	0x4b46bf0a, 0x4523, 0x4e57, { 0xaa,0x38,0xa8,0x79,0x87,0xc9,0x10,0xd9 }
+};
+const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TRANSPORT_V6 = {
+	0x38d87722, 0xad83, 0x4f11, { 0xa9,0x1f,0xdf,0x0f,0xb0,0x77,0x22,0x5b }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V4 = {
+	0x191a8a46, 0x0bf8, 0x46cf, { 0xb0,0x45,0x4b,0x45,0xdf,0xa6,0xa3,0x24 }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_V6 = {
+	0x80c342e3, 0x1e53, 0x4d6f, { 0x9b,0x44,0x03,0xdf,0x5a,0xee,0xe1,0x54 }
+};
+const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V4 = {
+	0x70a4196c, 0x835b, 0x4fb0, { 0x98,0xe8,0x07,0x5f,0x4d,0x97,0x7d,0x46 }
+};
+const GUID FWPM_CALLOUT_IPSEC_OUTBOUND_TUNNEL_V6 = {
+	0xf1835363, 0xa6a5, 0x4e62, { 0xb1,0x80,0x23,0xdb,0x78,0x9d,0x8d,0xa6 }
+};
+const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V4 = {
+	0x28829633, 0xc4f0, 0x4e66, { 0x87,0x3f,0x84,0x4d,0xb2,0xa8,0x99,0xc7 }
+};
+const GUID FWPM_CALLOUT_IPSEC_FORWARD_INBOUND_TUNNEL_V6 = {
+	0xaf50bec2, 0xc686, 0x429a, { 0x88,0x4d,0xb7,0x44,0x43,0xe7,0xb0,0xb4 }
+};
+const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V4 = {
+	0xfb532136, 0x15cb, 0x440b, { 0x93,0x7c,0x17,0x17,0xca,0x32,0x0c,0x40 }
+};
+const GUID FWPM_CALLOUT_IPSEC_FORWARD_OUTBOUND_TUNNEL_V6 = {
+	0xdae640cc, 0xe021, 0x4bee, { 0x9e,0xb6,0xa4,0x8b,0x27,0x5c,0x8c,0x1d }
+};
+const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V4 = {
+	0x6ac141fc, 0xf75d, 0x4203, { 0xb9,0xc8,0x48,0xe6,0x14,0x9c,0x27,0x12 }
+};
+const GUID FWPM_CALLOUT_IPSEC_ALE_CONNECT_V6 = {
+	0x4c0dda05, 0xe31f, 0x4666, { 0x90,0xb0,0xb3,0xdf,0xad,0x34,0x12,0x9a  }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V4 = {
+	0x3df6e7de, 0xfd20, 0x48f2, { 0x9f,0x26,0xf8,0x54,0x44,0x4c,0xba,0x79 }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_TUNNEL_ALE_ACCEPT_V6 = {
+	0xa1e392d3, 0x72ac, 0x47bb, { 0x87,0xa7,0x01,0x22,0xc6,0x94,0x34,0xab }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V4 = {
+	0x7dff309b, 0xba7d, 0x4aba, { 0x91,0xaa,0xae,0x5c,0x66,0x40,0xc9,0x44 }
+};
+const GUID FWPM_CALLOUT_IPSEC_INBOUND_INITIATE_SECURE_V6 = {
+	0xa9a0d6d9, 0xc58c, 0x474e, { 0x8a,0xeb,0x3c,0xfe,0x99,0xd6,0xd5,0x3d }
+};
 
 /* integrity config, missing in some MinGW versions */
 #ifndef IPSEC_AUTH_CONFIG_HMAC_MD5_96
diff -ruN strongswan-5.8.4/src/libcharon/plugins/stroke/stroke_cred.c strongswancont-5.8.4-svc/src/libcharon/plugins/stroke/stroke_cred.c
--- strongswan-5.8.4/src/libcharon/plugins/stroke/stroke_cred.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/stroke/stroke_cred.c	2022-07-06 15:47:33.894969000 +0300
@@ -1043,29 +1043,91 @@
 	return TRUE;
 }
 
+static bool load_from_usbbar(chunk_t line, int line_nr, char *path, 
+												private_key_t **result)
+{
+	/*get protected password filename*/
+	chunk_t filename;
+
+	err_t ugh = extract_value(&filename, &line);
+
+	if (ugh != NULL)
+	{
+		DBG1(DBG_CFG, "line %d: %s", line_nr, ugh);
+		return FALSE;
+	}
+	if (filename.len == 0)
+	{
+		DBG1(DBG_CFG, "line %d: empty filename", line_nr);
+		return FALSE;
+	}
+
+	snprintf(path, PATH_MAX, "%.*s", (int)filename.len, filename.ptr);
+
+	*result = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+		KEY_ANY, BUILD_USBBAR_PASS, path, BUILD_END);
+
+	return TRUE;
+}
+
+static bool load_from_bpki(chunk_t line, int line_nr,
+							private_key_t **result)
+{
+	if (line.len == 0)
+	{
+		DBG1(DBG_CFG, "line %d: empty params", line_nr);
+		return FALSE;
+	}
+
+	*result = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+		KEY_BIGN, BUILD_BPKI_PARAMS, line, BUILD_END);
+
+	return TRUE;
+}
+
 /**
  * Load a private key
  */
 static bool load_private(mem_cred_t *secrets, chunk_t line, int line_nr,
 						 FILE *prompt, key_type_t key_type)
 {
-	char path[PATH_MAX];
-	private_key_t *key;
+	char path[PATH_MAX], key_from[1024] = {0,};
+	private_key_t *key = NULL;
 
-	if (!load_from_file(line, line_nr, prompt, path, CRED_PRIVATE_KEY,
+	if(key_type == KEY_BIGN) 
+	{
+		strcpy(key_from, "BPKI Containers");
+		if(!load_from_bpki(line, line_nr, &key))
+		{
+			return FALSE;
+		}
+	}
+	else if(key_type != KEY_ANY) 
+	{
+		if (!load_from_file(line, line_nr, prompt, path, CRED_PRIVATE_KEY,
 						key_type, (void**)&key))
+		{
+			return FALSE;
+		}
+		strcpy(key_from, path);
+	}
+	else 
 	{
-		return FALSE;
+		strcpy(key_from, "USB-Barrier");
+		if(!load_from_usbbar(line, line_nr, path, &key))
+		{
+			return FALSE;			
+		}
 	}
 	if (key)
 	{
 		DBG1(DBG_CFG, "  loaded %N private key from '%s'",
-			 key_type_names, key->get_type(key), path);
+			 key_type_names, key->get_type(key), key_from);
 		secrets->add_key(secrets, key);
 	}
 	else
 	{
-		DBG1(DBG_CFG, "  loading private key from '%s' failed", path);
+		DBG1(DBG_CFG, "  loading private key from '%s' failed", key_from);
 	}
 	return TRUE;
 }
@@ -1347,10 +1409,27 @@
 				break;
 			}
 		}
+		/* USB-Barrier private key storage support: */
+		else if (match("USBBAR", &token))
+		{
+			if(!load_private(secrets, line, line_nr, prompt, KEY_ANY))
+			{
+				break;
+			}
+		}
+		/* BPKI: */
+		else if (match("BPKI", &token))
+		{
+			if(!load_private(secrets, line, line_nr, prompt, KEY_BIGN))
+			{
+				break;
+			}
+		}
 		else
 		{
 			DBG1(DBG_CFG, "line %d: token must be either RSA, ECDSA, BLISS, "
-						  "PKCS8 P12, PIN, PSK, EAP, XAUTH or NTLM", line_nr);
+						  "PKCS8 P12, PIN, PSK, EAP, XAUTH, NTLM, "
+						  "USBBAR or BPKI", line_nr);
 			break;
 		}
 	}
